BEGIN{
    hex[0] = 0;     hex[1] = 1;     hex[2] = 2;     hex[3] = 3;
    hex[4] = 4;     hex[5] = 5;     hex[6] = 6;     hex[7] = 7;
    hex[8] = 8;     hex[9] = 9;     hex["A"] = 10;  hex["B"] = 11;
    hex["C"] = 12;  hex["D"] = 13;  hex["E"] = 14;  hex["F"] = 15;
	printf("  integer i;\n");
	printf("  initial\n");
	printf("    begin\n");
   last_addr = 0;
   last_len = 0;
}
END{
	addr = last_addr + last_len;
	len = rom_size * 2 - addr;
	if (len > 0) {
		printf("      for (i = %d ; i < SIZE ; i = i + 1)\n", addr/2);
		printf("\trom[i] <= 16\'hFFFF;\n");
	}
	printf("    end\n");
}
{
	sum = 0;
	len = hex2dec($1, 2);
	sum += len;
	x = hex2dec($1, 4);
	sum += x;
	addr = hex2dec($1, 6);
	sum += addr;
	addr += x * 256;
	rtype = hex2dec($1, 8);
	sum += rtype;
	for (i=0; i<len; i++) {
		data[i] = hex2dec($1, 10+i*2);
		sum += data[i];
	}
	isum = hex2dec($1, 10+len*2);
	sum += isum;
	sum = sum % 256;
	if (sum != 0) {
		printf("line %d: ihex format error!\n",NR);
		exit(1);
	}
	if ( rtype == 0) {
		print_ihex(rtype, addr, data, len);
		last_addr = addr;
		last_len = len;
	}
}

function hex2dec(str, i, x) {
    x = hex[substr(str,i,1)] * 16 + hex[substr(str,i+1,1)];
    return x;
}

function print_ihex(rtype, addr, data, len, sum) {
#	printf("// addr %03X type %d\n", addr, rtype);
	printf("//\n");
	for (i=0; i+1<len; i = i+2) {
		printf("\trom[%4d] <= 16\'h",(addr + i)/2);
		printf("%02X%02X;\n", data[i+1], data[i]);
	}
        return 0;
}
